#pragma once

#include <Windows.h>
#include <psapi.h>

// Type definitions for CFG-related structures and functions
typedef enum _VIRTUAL_MEMORY_INFORMATION_CLASS
{
    VmPrefetchInformation,
    VmPagePriorityInformation,
    VmCfgCallTargetInformation
} VIRTUAL_MEMORY_INFORMATION_CLASS;

typedef struct _MEMORY_RANGE_ENTRY
{
    PVOID   VirtualAddress;
    SIZE_T  NumberOfBytes;
} MEMORY_RANGE_ENTRY, *PMEMORY_RANGE_ENTRY;

typedef struct _VM_INFORMATION
{
    DWORD                   dwNumberOfOffsets;
    DWORD                   dwMustBeZero;
    PDWORD                  pdwOutput;
    PCFG_CALL_TARGET_INFO   ptOffsets;
} VM_INFORMATION, *PVM_INFORMATION;

typedef NTSTATUS(NTAPI* NTSETINFORMATIONVIRTUALMEMORY)(
    HANDLE                             hProcess,
    VIRTUAL_MEMORY_INFORMATION_CLASS   VmInformationClass,
    ULONG_PTR                          NumberOfEntries,
    PMEMORY_RANGE_ENTRY                VirtualAddresses,
    PVOID                              VmInformation,
    ULONG                              VmInformationLength
);

typedef BOOL(WINAPI* SETPROCESSVALIDCALLTARGETS)(
    HANDLE                   hProcess,
    PVOID                    VirtualAddress,
    SIZE_T                   RegionSize,
    ULONG                    NumberOfOffsets,
    PCFG_CALL_TARGET_INFO    OffsetInformation
);

#define NT_SUCCESS(Status) (((NTSTATUS)(Status)) >= 0)

// Helper function to get memory allocation base and region size
BOOL GetMemoryAllocationBaseAndRegionSize(PVOID pvAddress, PVOID* ppvAllocationBase, PSIZE_T pstRegionSize);

// Main function to add CFG exception
LONG AddCfgException(PVOID targetAddress);
